## redsocks 0.2

=== Makefile ===
OBJS := parser.o main.o redsocks.o log.o http-connect.o socks4.o socks5.o http-relay.o base.o base64.o md5.o http-auth.o utils.o redudp.o dnstc.o
SRCS := $(OBJS:.o=.c)
CONF := config.h
DEPS := .depend
OUT := redsocks

LIBS := -levent
CFLAGS += -g -O2
override CFLAGS += -std=gnu99 -Wall

all: $(OUT)

.PHONY: all clean distclean

tags: *.c *.h
	ctags -R

$(CONF):
	@case `uname` in \
	Linux*) \
		echo "#define USE_IPTABLES" >$(CONF) \
		;; \
	OpenBSD) \
		echo "#define USE_PF" >$(CONF) \
		;; \
	*) \
		echo "Unknown system, only generic firewall code is compiled" 1>&2; \
		echo "/* Unknown system, only generic firewall code is compiled */" >$(CONF) \
		;; \
	esac

base.c: $(CONF)

$(DEPS): $(SRCS)
	gcc -MM $(SRCS) 2>/dev/null >$(DEPS) || \
	( \
		for I in $(wildcard *.h); do \
			export $${I//[-.]/_}_DEPS="`sed '/^\#[ \t]*include \?"\(.*\)".*/!d;s//\1/' $$I`"; \
		done; \
		echo -n >$(DEPS); \
		for SRC in $(SRCS); do \
			echo -n "$${SRC%.c}.o: " >>$(DEPS); \
			export SRC_DEPS="`sed '/\#[ \t]*include \?"\(.*\)".*/!d;s//\1/' $$SRC | sort`"; \
			while true; do \
				export SRC_DEPS_OLD="$$SRC_DEPS"; \
				export SRC_DEEP_DEPS=""; \
				for HDR in $$SRC_DEPS; do \
					eval export SRC_DEEP_DEPS="\"$$SRC_DEEP_DEPS \$$$${HDR//[-.]/_}_DEPS\""; \
				done; \
				export SRC_DEPS="`echo $$SRC_DEPS $$SRC_DEEP_DEPS | sed 's/  */\n/g' | sort -u`"; \
				test "$$SRC_DEPS" = "$$SRC_DEPS_OLD" && break; \
			done; \
			echo $$SRC $$SRC_DEPS >>$(DEPS); \
		done; \
	)

-include $(DEPS)

$(OUT): $(OBJS)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS) $(LIBS)

clean:
	$(RM) $(OUT) $(CONF) $(OBJS)

distclean: clean
	$(RM) tags $(DEPS)

## redsocks 0.4+dfsg

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,9 @@
-OBJS := parser.o main.o redsocks.o log.o http-connect.o socks4.o socks5.o http-relay.o base.o base64.o md5.o http-auth.o utils.o redudp.o dnstc.o
+OBJS := parser.o main.o redsocks.o log.o http-connect.o socks4.o socks5.o http-relay.o base.o base64.o md5.o http-auth.o utils.o redudp.o dnstc.o gen/version.o
 SRCS := $(OBJS:.o=.c)
 CONF := config.h
 DEPS := .depend
 OUT := redsocks
+VERSION := 0.4
 
 LIBS := -levent
 CFLAGS += -g -O2
@@ -28,6 +29,27 @@
 		echo "/* Unknown system, only generic firewall code is compiled */" >$(CONF) \
 		;; \
 	esac
+
+# Dependency on .git is useful to rebuild `version.c' after commit, but it breaks non-git builds.
+gen/version.c: *.c *.h gen/.build
+	rm -f $@.tmp
+	echo '/* this file is auto-generated during build */' > $@.tmp
+	echo '#include "../version.h"' >> $@.tmp
+	echo 'const char* redsocks_version = ' >> $@.tmp
+	if [ -d .git ]; then \
+		echo '"redsocks.git/'`git describe --tags`'"'; \
+		if [ `git status --porcelain | grep -v -c '^??'` != 0 ]; then \
+			echo '"-unclean"'; \
+		fi \
+	else \
+		echo '"redsocks/$(VERSION)"'; \
+	fi >> $@.tmp
+	echo ';' >> $@.tmp
+	mv -f $@.tmp $@
+
+gen/.build:
+	mkdir -p gen
+	touch $@
 
 base.c: $(CONF)
 
@@ -64,3 +86,4 @@
 
 distclean: clean
 	$(RM) tags $(DEPS)
+	$(RM) -r gen

=== debian/changelog ===
redsocks (0.4+dfsg-4) unstable; urgency=medium

  * Set Priority to optional
  * Bump Standards to 3.9.8; no changes needed
  * Enable all hardening flags
  * Depend on lsb-base for /lib/lsb/init-functions
  * systemd: set the Documentation field in redsocks.service

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Sat, 17 Dec 2016 01:22:49 +0200

redsocks (0.4+dfsg-3) unstable; urgency=medium

  * Bump standards to 3.9.7; no changes needed.
  * d/control: use HTTPS for Vcs-* fields.
  * d/copyright: update debian/* copyright years.
  * d/copyright: mark debian/* license as permissive.
  * d/watch: move away from githubredir.debian.net.
  * debian/: change my e-mail address.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 11 Feb 2016 17:35:21 +0200

redsocks (0.4+dfsg-2) unstable; urgency=low

  * Bump standards version to 3.9.5
    + no changes needed
  * Add systemd support
  * /etc/default/redsocks: start redsocks by default
  * debian/copyright: migrate to Debian copyright format 1.0
  * Change the default config file location to /etc/redsocks.conf (LP: #1047937)
  * Add DEP3 headers to patches
  * Manpage fixes

 -- Apollon Oikonomopoulos <apoikos@gmail.com>  Fri, 01 Nov 2013 12:34:17 +0200

redsocks (0.4+dfsg-1) unstable; urgency=low

  * New upstream release. Fixes a busy-wait triggered on fd exhaustion.
  * Fix debian/watch to properly detect upstream versions.
  * Include upstream commmit 290f19 which fixes a DNS resolution bug.
  * Bump debhelper compat to 9.
  * Remove source doc/ subdirectory as it includes non-DFSG-free RFCs, and
    files of unspecified origin and copyright.

 -- Apollon Oikonomopoulos <apoikos@gmail.com>  Thu, 24 May 2012 16:00:05 +0300

redsocks (0.2-1) unstable; urgency=low

  * Initial release (Closes: #649309)

 -- Apollon Oikonomopoulos <apoikos@gmail.com>  Mon, 14 Nov 2011 14:42:55 +0200

=== debian/control ===
Source: redsocks
Section: net
Priority: optional
Maintainer: Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends: debhelper (>= 9), libevent-dev, dh-systemd (>= 1.5)
Standards-Version: 3.9.8
Homepage: http://darkk.net.ru/redsocks/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/redsocks.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/redsocks.git;a=summary

Package: redsocks
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, lsb-base (>= 3.0-6)
Enhances: tor
Description: arbitrary TCP connection redirector to a SOCKS or HTTPS proxy server
 Redsocks is a daemon running on the local system, that will transparently
 tunnel any TCP connection via a remote SOCKS4, SOCKS5 or HTTP proxy server. It
 uses the system firewall's redirection facility to intercept TCP connections,
 thus the redirection is system-wide, with fine-grained control, and does 
 not depend on LD_PRELOAD libraries.
 .
 Redsocks supports tunneling TCP connections and UDP packets. It has
 authentication support for both, SOCKS and HTTP proxies.
 .
 Also included is a small DNS server returning answers with the "truncated" flag
 set for any UDP query, forcing the resolver to use TCP.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with systemd

## redsocks 0.5

=== Makefile ===
--- 
+++ 
@@ -1,17 +1,26 @@
+-include make.conf
 OBJS := parser.o main.o redsocks.o log.o http-connect.o socks4.o socks5.o http-relay.o base.o base64.o md5.o http-auth.o utils.o redudp.o dnstc.o gen/version.o
+ifeq ($(DBG_BUILD),1)
+OBJS += debug.o
+endif
 SRCS := $(OBJS:.o=.c)
 CONF := config.h
 DEPS := .depend
 OUT := redsocks
-VERSION := 0.4
+VERSION := 0.5
 
-LIBS := -levent
+LIBS := -levent_core
+ifeq ($(DBG_BUILD),1)
+# -levent_extra is required only for `http` and `debug`
+LIBS += -levent_extra
+endif
 CFLAGS += -g -O2
-override CFLAGS += -std=gnu99 -Wall
+# _GNU_SOURCE is used to get splice(2), it also implies _BSD_SOURCE
+override CFLAGS += -std=c99 -D_XOPEN_SOURCE=600 -D_DEFAULT_SOURCE -D_GNU_SOURCE -Wall
 
 all: $(OUT)
 
-.PHONY: all clean distclean
+.PHONY: all clean distclean test
 
 tags: *.c *.h
 	ctags -R
@@ -29,6 +38,9 @@
 		echo "/* Unknown system, only generic firewall code is compiled */" >$(CONF) \
 		;; \
 	esac
+ifeq ($(DBG_BUILD),1)
+	echo "#define DBG_BUILD 1" >>$(CONF)
+endif
 
 # Dependency on .git is useful to rebuild `version.c' after commit, but it breaks non-git builds.
 gen/version.c: *.c *.h gen/.build
@@ -39,7 +51,7 @@
 	if [ -d .git ]; then \
 		echo '"redsocks.git/'`git describe --tags`'"'; \
 		if [ `git status --porcelain | grep -v -c '^??'` != 0 ]; then \
-			echo '"-unclean"'; \
+			echo '"'"-unclean-$$(date --rfc-3339=seconds | tr ' ' 'T')-$${USER}@$$(uname -n)"'"'; \
 		fi \
 	else \
 		echo '"redsocks/$(VERSION)"'; \
@@ -87,3 +99,13 @@
 distclean: clean
 	$(RM) tags $(DEPS)
 	$(RM) -r gen
+
+tests/__build-tstamp__: $(OUT) tests/[a-z]* tests/[a-z]*/*
+	cd tests && ./build
+	touch $@
+
+tests/prlimit-nofile: tests/prlimit-nofile.c
+	$(CC) $(CFLAGS) -o $@ $^
+
+test: tests/__build-tstamp__ tests/prlimit-nofile
+	cd tests && env $(TEST_ENV) ./run

=== debian/changelog ===
redsocks (0.5-2) unstable; urgency=medium

  * Fix http-relay and http-connect modes with libevent 2.1 (Closes: #892872)
  * Bump Standards-Version to 4.1.3; no changes needed
  * Bump dh compat to 11
    + Drop B-D on dh-systemd
    + Do not pass --with=systemd to dh
  * Switch Vcs-* URLs to salsa.d.o
  * d/copyright: bump debian/* years

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 29 Mar 2018 23:05:32 +0300

redsocks (0.5-1) unstable; urgency=medium

  * New upstream release
  * Drop patches merged upstream
    + 0001-Fix-bug-in-DNS-resolution-results-were-ignored-since.patch
    + add_external_diagram_links
  * Refresh fix_default_config_location.patch
  * Disable running tests on build
  * Do not ship README.html; it is the same as README but contains references
    to external resources.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 02 Jan 2017 14:18:48 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: net
 Priority: optional
 Maintainer: Apollon Oikonomopoulos <apoikos@debian.org>
-Build-Depends: debhelper (>= 9), libevent-dev, dh-systemd (>= 1.5)
-Standards-Version: 3.9.8
+Build-Depends: debhelper (>= 11~), libevent-dev
+Standards-Version: 4.1.3
 Homepage: http://darkk.net.ru/redsocks/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/redsocks.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/redsocks.git;a=summary
+Vcs-Git: https://salsa.debian.org/debian/redsocks.git
+Vcs-Browser: https://salsa.debian.org/debian/redsocks
 
 Package: redsocks
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -7,4 +7,6 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --with systemd
+	dh $@
+
+.PHONY: override_dh_auto_test

=== debian/watch ===
version=3

# Use githubredir.debian.net for the time being
opts=dversionmangle=s/\+dfsg$// \
  https://github.com/darkk/redsocks/releases .*/release-(.*).tar.gz
